import { defineComponent as ie, ref as r, onMounted as H, withDirectives as ne, createVNode as o, mergeProps as N, resolveComponent as y, resolveDirective as ue, unref as oe, toRef as Q, Fragment as re, nextTick as _, isVNode as de } from "vue";
import ce from "qs";
import "../../selectArea/index.js";
import "../../selectDate/index.js";
import "../../selectTime/index.js";
import "../../trend/index.js";
import "../../progress/index.js";
import "../../notification/index.js";
import "../index.js";
import { KCustomElement as B } from "../../customElement/index.js";
import "../../form/index.js";
import { tableProps as me, tableEmits as ve } from "./props.js";
import { Check as se, Close as fe, Edit as ge } from "@element-plus/icons-vue";
import { createNamespacs as he, getI18nKey as we, getValue as W } from "@tomiaa/utils";
import "../../theme-chalk/lib/vue3-components/table.js";
import { useI18n as Te } from "vue-i18n";
function ye(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !de(e);
}
const P = he("table"), Ne = ie({
  name: "KTable",
  props: me,
  emits: ve,
  setup(e, {
    attrs: L,
    slots: x,
    emit: s,
    expose: X
  }) {
    const {
      t: Y
    } = Te(), j = r(""), U = r(""), {
      append: Z,
      empty: p = () => e.emptyTip && b.value && j.value,
      page: ee,
      editControlIcon: O,
      editIcon: q
    } = x, f = r({}), h = r({}), te = (c) => c == null ? void 0 : c.map((g) => {
      const E = {};
      for (const a in g)
        E[a] = oe(g[a]);
      for (const a in g) {
        const R = we(g[a]);
        R && (E[a] = Y(R));
      }
      const {
        slot: z,
        action: w,
        actionConfig: t,
        editable: D,
        editableConfig: u,
        ...C
      } = E, l = r({}), v = r({}), T = {
        header: x.header,
        default(a) {
          var R, J;
          if (z)
            return (R = x[z]) == null ? void 0 : R.call(x, a);
          if (w || t) {
            const {
              $index: i,
              row: m
            } = a;
            let d = [{
              el: "el-button",
              size: "small",
              "v-if": typeof (t == null ? void 0 : t.showEdit) < "u" ? t == null ? void 0 : t.showEdit : e.actionConfig.showEdit,
              onClick: () => {
                if (e.editRow) {
                  if (f.value[i]) {
                    Object.assign(a.row, h.value[i]), delete h.value[i], delete f.value[i], s("confirmEditRow", a);
                    return;
                  }
                  h.value[i] = JSON.parse(JSON.stringify(m)), f.value[i] = !0;
                }
                s("edit", a);
              },
              children: f.value[i] ? (t == null ? void 0 : t.editRowEnterText) || e.actionConfig.editRowEnterText || "\u786E\u5B9A" : (t == null ? void 0 : t.editText) || e.actionConfig.editText || "\u7F16\u8F91"
            }, {
              el: "el-button",
              size: "small",
              type: "danger",
              "v-if": typeof (t == null ? void 0 : t.showDelete) < "u" ? t == null ? void 0 : t.showDelete : e.actionConfig.showDelete,
              onClick: () => {
                if (e.editRow) {
                  delete h.value[i], delete f.value[i], s("cancelEditRow", a);
                  return;
                }
                s("delete", a);
              },
              children: f.value[i] ? (t == null ? void 0 : t.editRowCloseText) || e.actionConfig.editRowCloseText || "\u53D6\u6D88" : (t == null ? void 0 : t.deleteText) || ((J = e.actionConfig) == null ? void 0 : J.deleteText) || "\u5220\u9664"
            }];
            return e.actionConfig.custom && (d = e.actionConfig.custom(d, a)), t != null && t.custom && (d = t.custom(d, a)), o(B, {
              list: d
            }, null);
          }
          if (D || u) {
            const {
              row: i,
              column: m,
              $index: d
            } = a, n = m.id + d, A = () => {
              delete v.value[n], delete l.value[n];
            };
            let G = [{
              el: "el-icon",
              color: "var(--el-color-success)",
              size: "1.2em",
              "v-if": u == null ? void 0 : u.showEnter,
              onClick() {
                i[m.property] = v.value[n], A(), s("confirmEditCell", a);
              },
              children: se
            }, {
              el: "el-icon",
              size: "1.2em",
              color: "var(--el-color-danger)",
              "v-if": u == null ? void 0 : u.showClose,
              onClick() {
                A(), s("cancelEditCell", a);
              },
              children: fe
            }];
            return u != null && u.custom && (G = u.custom(G, a, Q(l.value, n))), o("div", {
              class: [P.e("editable"), P.is("editable", l.value[n])]
            }, [l.value[n] ? o(y("el-input"), {
              size: "small",
              modelValue: v.value[n],
              "onUpdate:modelValue": (le) => v.value[n] = le
            }, null) : i[m.property], l.value[n] ? o(re, null, [
              (O == null ? void 0 : O({
                ...a,
                isEdit: Q(l.value, n)
              })) || o(B, {
                list: G
              }, null)
            ]) : q ? o("span", {
              onClick: () => {
                v.value[n] = i[m.property];
              }
            }, [q({
              ...a,
              isEdit: Q(l.value, n)
            })]) : o(y("el-icon"), {
              size: "1.2em",
              onClick: () => {
                v.value[n] = i[m.property], l.value[n] = !l.value[n];
              }
            }, {
              default: () => [o(ge, null, null)]
            })]);
          }
          if (e.editRow) {
            const {
              row: i,
              column: m,
              $index: d
            } = a;
            return o("div", {
              class: [P.e("editable"), P.is("editable", f.value[d])]
            }, [f.value[d] ? o(y("el-input"), {
              size: "small",
              modelValue: h.value[d][m.property],
              "onUpdate:modelValue": (n) => h.value[d][m.property] = n
            }, null) : i[m.property]]);
          }
        }
      };
      return o(y("el-table-column"), C, ye(T) ? T : {
        default: () => [T]
      });
    }), ae = () => o(y("el-pagination"), N({
      class: P.b("pagination"),
      defaultCurrentPage: e.defaultCurrentPage,
      defaultPageSize: e.defaultPageSize,
      currentPage: M.value,
      pageSize: $.value,
      total: K.value,
      ref: S,
      layout: "->,sizes,prev,pager,next,jumper,total",
      "hide-on-single-page": !0
    }, L, {
      "onUpdate:currentPage": async (c) => {
        M.value = c, await _(), k();
      },
      "onUpdate:page-size": async (c) => {
        $.value = c, await _(), k();
      }
    }), {
      default: ee
    }), S = r(), F = r(), V = r(null), K = r(0), M = r(e.defaultCurrentPage || 1), $ = r(e.defaultPageSize || 10), b = r(!1), k = () => {
      var D, u, C;
      b.value = !0, V.value = null;
      let c;
      e.emptyTip && (j.value = e.emptyTip, clearTimeout(c), c = setTimeout(() => {
        j.value = e.emptyTipTimeoutText;
      }, e.emptyTipTimeout));
      let g;
      e.elLoadingTextTimeoutText && (U.value = e.elementLoadingText, clearTimeout(g), setTimeout(() => {
        const l = document.querySelector(".el-loading-text");
        l && (l.innerHTML = e.elLoadingTextTimeoutText);
      }, e.elLoadingTextTimeout));
      const E = e.server, z = {
        [((D = e.replaceFields) == null ? void 0 : D.pageSize) || "pageSize"]: S.value.pageSize,
        [((u = e.replaceFields) == null ? void 0 : u.currentPage) || "currentPage"]: S.value.currentPage
      }, w = {};
      if (e.withDataPath !== !1) {
        const l = {
          get: "params",
          post: "data"
        }, v = e.withDataPath || l[(((C = e.getConfig) == null ? void 0 : C.method) || "get").toLocaleLowerCase()];
        v && (w[v] = {});
        const T = w[v] || w;
        Object.assign(T, e.withPagePath && typeof e.withPagePath == "string" ? {
          [e.withPagePath]: z
        } : z), Object.assign(T, e.withQueryPath && typeof e.withQueryPath == "string" ? {
          [e.withQueryPath]: e.withQuery
        } : e.withQuery);
      }
      const t = {
        url: e.getUrl,
        ...w,
        ...e.getConfig
      };
      e.stringify && t.data && (t.data = ce.stringify(t.data)), s("beforeGetData", t), E(t).then((l) => {
        s("afterGetData", l), V.value = W(e.dataPath, l), K.value = W(e.totalPath, l);
      }).catch((l) => {
        s("failToGetData", l);
      }).finally(() => {
        clearTimeout(c), clearTimeout(g), b.value = !1;
      });
    };
    e.showPagination && H(k);
    const I = {
      getData: k
    };
    return H(() => {
      I.elPagination = S.value, I.elTable = F.value;
    }), X(I), () => ne(o("div", N({
      class: P.b(),
      "element-loading-text": U.value
    }, L), [o(y("el-table"), N({
      data: V.value,
      ref: F
    }, L), {
      default: () => [te(e.options)],
      append: Z,
      empty: p
    }), e.showPagination && ae(), e.showLoadInGet && b.value]), [[ue("loading"), e.showLoadInGet && b.value]]);
  }
});
export {
  Ne as default
};
